// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from fadecandy_msgs:msg/LEDArray.idl
// generated code does not contain a copyright notice

#ifndef FADECANDY_MSGS__MSG__DETAIL__LED_ARRAY__FUNCTIONS_H_
#define FADECANDY_MSGS__MSG__DETAIL__LED_ARRAY__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "fadecandy_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "fadecandy_msgs/msg/detail/led_array__struct.h"

/// Initialize msg/LEDArray message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * fadecandy_msgs__msg__LEDArray
 * )) before or use
 * fadecandy_msgs__msg__LEDArray__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
bool
fadecandy_msgs__msg__LEDArray__init(fadecandy_msgs__msg__LEDArray * msg);

/// Finalize msg/LEDArray message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
void
fadecandy_msgs__msg__LEDArray__fini(fadecandy_msgs__msg__LEDArray * msg);

/// Create msg/LEDArray message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * fadecandy_msgs__msg__LEDArray__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
fadecandy_msgs__msg__LEDArray *
fadecandy_msgs__msg__LEDArray__create();

/// Destroy msg/LEDArray message.
/**
 * It calls
 * fadecandy_msgs__msg__LEDArray__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
void
fadecandy_msgs__msg__LEDArray__destroy(fadecandy_msgs__msg__LEDArray * msg);

/// Check for msg/LEDArray message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
bool
fadecandy_msgs__msg__LEDArray__are_equal(const fadecandy_msgs__msg__LEDArray * lhs, const fadecandy_msgs__msg__LEDArray * rhs);

/// Copy a msg/LEDArray message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
bool
fadecandy_msgs__msg__LEDArray__copy(
  const fadecandy_msgs__msg__LEDArray * input,
  fadecandy_msgs__msg__LEDArray * output);

/// Initialize array of msg/LEDArray messages.
/**
 * It allocates the memory for the number of elements and calls
 * fadecandy_msgs__msg__LEDArray__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
bool
fadecandy_msgs__msg__LEDArray__Sequence__init(fadecandy_msgs__msg__LEDArray__Sequence * array, size_t size);

/// Finalize array of msg/LEDArray messages.
/**
 * It calls
 * fadecandy_msgs__msg__LEDArray__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
void
fadecandy_msgs__msg__LEDArray__Sequence__fini(fadecandy_msgs__msg__LEDArray__Sequence * array);

/// Create array of msg/LEDArray messages.
/**
 * It allocates the memory for the array and calls
 * fadecandy_msgs__msg__LEDArray__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
fadecandy_msgs__msg__LEDArray__Sequence *
fadecandy_msgs__msg__LEDArray__Sequence__create(size_t size);

/// Destroy array of msg/LEDArray messages.
/**
 * It calls
 * fadecandy_msgs__msg__LEDArray__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
void
fadecandy_msgs__msg__LEDArray__Sequence__destroy(fadecandy_msgs__msg__LEDArray__Sequence * array);

/// Check for msg/LEDArray message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
bool
fadecandy_msgs__msg__LEDArray__Sequence__are_equal(const fadecandy_msgs__msg__LEDArray__Sequence * lhs, const fadecandy_msgs__msg__LEDArray__Sequence * rhs);

/// Copy an array of msg/LEDArray messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_fadecandy_msgs
bool
fadecandy_msgs__msg__LEDArray__Sequence__copy(
  const fadecandy_msgs__msg__LEDArray__Sequence * input,
  fadecandy_msgs__msg__LEDArray__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // FADECANDY_MSGS__MSG__DETAIL__LED_ARRAY__FUNCTIONS_H_
